"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _dmx = require("../util/dmx");

var _dmx2 = _interopRequireDefault(_dmx);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Universe = function () {
  function Universe(root, props) {
    (0, _classCallCheck3.default)(this, Universe);

    _initialiseProps.call(this);

    this.root = root;
    this.props = props;
    this.children = [];
    var _props$name = props.name,
        name = _props$name === undefined ? "default-universe" : _props$name,
        _props$mode = props.mode,
        mode = _props$mode === undefined ? "null" : _props$mode,
        port = props.port;

    this.addUniverse({ name: name, mode: mode, port: port });
  }
  // Store all the children here


  (0, _createClass3.default)(Universe, [{
    key: "appendChild",

    // Add children
    value: function appendChild(child) {
      child.root = this.props.name;
      this.children.push(child);
    }

    // Remove children

  }, {
    key: "removeChild",
    value: function removeChild(child) {
      var index = this.children.indexOf(child);
      this.children.splice(index, 1);
    }
  }, {
    key: "renderChildren",
    value: function renderChildren() {
      if (Array.isArray(this.children)) {
        return this.children.map(function (c) {
          return c.render();
        }).reduce(function (prev, next) {
          return (0, _extends4.default)({}, prev, (0, _defineProperty3.default)({}, Object.keys(next)[0], Object.values(next)[0]));
        }, {});
      }
      return this.children.render();
    }
  }, {
    key: "render",
    value: function render() {
      return { name: this.props.name, channels: this.renderChildren() };
    }
  }]);
  return Universe;
}();

var _initialiseProps = function _initialiseProps() {
  var _this = this;

  this.children = [];

  this.addUniverse = function (_ref) {
    var name = _ref.name,
        _ref$mode = _ref.mode,
        mode = _ref$mode === undefined ? "null" : _ref$mode,
        port = _ref.port;

    _this.universe = _dmx2.default.addUniverse(name, mode, port);
    console.log("Added Universe:", name);
    /*state.universes.push({
      name,
      children: children.map(c => Object.assign({}, c.props))
    });*/
  };
};

exports.default = Universe;